// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_NATIVE_TYPES_MOJOM_FORWARD_H_
#define CONTENT_COMMON_NATIVE_TYPES_MOJOM_FORWARD_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/struct_ptr.h"




#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace content {
namespace mojom {
using EncodedAttributedStringDataView = mojo::native::NativeStructDataView;

using FrameOwnerPropertiesDataView = mojo::native::NativeStructDataView;

using FrameReplicationStateDataView = mojo::native::NativeStructDataView;

using VisualPropertiesDataView = mojo::native::NativeStructDataView;

using WebPreferencesDataView = mojo::native::NativeStructDataView;

using WebCursorDataView = mojo::native::NativeStructDataView;

using EditCommandDataView = mojo::native::NativeStructDataView;

using DidOverscrollParamsDataView = mojo::native::NativeStructDataView;

using SyntheticSmoothDragDataView = mojo::native::NativeStructDataView;

using SyntheticSmoothScrollDataView = mojo::native::NativeStructDataView;

using SyntheticPinchDataView = mojo::native::NativeStructDataView;

using SyntheticTapDataView = mojo::native::NativeStructDataView;

using SyntheticPointerActionDataView = mojo::native::NativeStructDataView;

using ScrollbarButtonsPlacement = mojo::NativeEnum;
using ScrollerStyle = mojo::NativeEnum;
using V8CacheOptions = mojo::NativeEnum;
using NetworkConnectionType = mojo::NativeEnum;
using Button = mojo::NativeEnum;
using PointerType = mojo::NativeEnum;
using InputEventAckState = mojo::NativeEnum;
using InputEventAckSource = mojo::NativeEnum;
using EventType = mojo::NativeEnum;
using Cancelability = mojo::NativeEnum;
using GestureDevice = mojo::NativeEnum;
using ScrollGranularity = mojo::NativeEnum;
using InertialPhaseState = mojo::NativeEnum;
using TouchState = mojo::NativeEnum;
using TouchAction = mojo::NativeEnum;
using EncodedAttributedString = mojo::native::NativeStruct;
using EncodedAttributedStringPtr = mojo::native::NativeStructPtr;

using FrameOwnerProperties = mojo::native::NativeStruct;
using FrameOwnerPropertiesPtr = mojo::native::NativeStructPtr;

using FrameReplicationState = mojo::native::NativeStruct;
using FrameReplicationStatePtr = mojo::native::NativeStructPtr;

using VisualProperties = mojo::native::NativeStruct;
using VisualPropertiesPtr = mojo::native::NativeStructPtr;

using WebPreferences = mojo::native::NativeStruct;
using WebPreferencesPtr = mojo::native::NativeStructPtr;

using WebCursor = mojo::native::NativeStruct;
using WebCursorPtr = mojo::native::NativeStructPtr;

using EditCommand = mojo::native::NativeStruct;
using EditCommandPtr = mojo::native::NativeStructPtr;

using DidOverscrollParams = mojo::native::NativeStruct;
using DidOverscrollParamsPtr = mojo::native::NativeStructPtr;

using SyntheticSmoothDrag = mojo::native::NativeStruct;
using SyntheticSmoothDragPtr = mojo::native::NativeStructPtr;

using SyntheticSmoothScroll = mojo::native::NativeStruct;
using SyntheticSmoothScrollPtr = mojo::native::NativeStructPtr;

using SyntheticPinch = mojo::native::NativeStruct;
using SyntheticPinchPtr = mojo::native::NativeStructPtr;

using SyntheticTap = mojo::native::NativeStruct;
using SyntheticTapPtr = mojo::native::NativeStructPtr;

using SyntheticPointerAction = mojo::native::NativeStruct;
using SyntheticPointerActionPtr = mojo::native::NativeStructPtr;




}  // namespace mojom
}  // namespace content
#include "cc/input/touch_action.h"
#include "content/common/cursors/webcursor.h"
#include "content/common/edit_command.h"
#include "content/common/frame_owner_properties.h"
#include "content/common/frame_replication_state.h"
#include "content/common/input/input_event.h"
#include "content/common/input/synthetic_pinch_gesture_params.h"
#include "content/common/input/synthetic_pointer_action_list_params.h"
#include "content/common/input/synthetic_smooth_drag_gesture_params.h"
#include "content/common/input/synthetic_smooth_scroll_gesture_params.h"
#include "content/common/input/synthetic_tap_gesture_params.h"
#include "content/common/visual_properties.h"
#include "content/public/common/input_event_ack_source.h"
#include "content/public/common/input_event_ack_state.h"
#include "content/public/common/web_preferences.h"
#include "net/base/network_change_notifier.h"
#include "third_party/blink/public/platform/web_gesture_device.h"
#include "third_party/blink/public/platform/web_gesture_event.h"
#include "third_party/blink/public/platform/web_input_event.h"
#include "third_party/blink/public/platform/web_mouse_wheel_event.h"
#include "third_party/blink/public/platform/web_pointer_properties.h"
#include "third_party/blink/public/platform/web_touch_point.h"
#include "ui/events/blink/did_overscroll_params.h"
#include "ui/events/blink/web_input_event_traits.h"
#include "ui/latency/ipc/latency_info_param_traits.h"

#endif  // CONTENT_COMMON_NATIVE_TYPES_MOJOM_FORWARD_H_