// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DATA_DECODER_PUBLIC_MOJOM_BUNDLED_EXCHANGES_PARSER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_DATA_DECODER_PUBLIC_MOJOM_BUNDLED_EXCHANGES_PARSER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/file.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace data_decoder {
namespace mojom {
namespace internal {
class BundleMetadata_Data;
class BundleIndexItem_Data;
class BundleResponse_Data;

#pragma pack(push, 1)
class  BundleMetadata_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BundleMetadata_Data));
      new (data()) BundleMetadata_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BundleMetadata_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BundleMetadata_Data>(index_);
    }
    BundleMetadata_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::BundleIndexItem_Data>>> index;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> manifest_url;

 private:
  BundleMetadata_Data();
  ~BundleMetadata_Data() = delete;
};
static_assert(sizeof(BundleMetadata_Data) == 24,
              "Bad sizeof(BundleMetadata_Data)");
// Used by BundleMetadata::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BundleMetadata_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BundleMetadata_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BundleMetadata_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BundleMetadata_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BundleMetadata_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  BundleIndexItem_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BundleIndexItem_Data));
      new (data()) BundleIndexItem_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BundleIndexItem_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BundleIndexItem_Data>(index_);
    }
    BundleIndexItem_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> request_url;
  mojo::internal::Pointer<mojo::internal::String_Data> request_method;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::String_Data>>> request_headers;
  uint64_t response_offset;
  uint64_t response_length;

 private:
  BundleIndexItem_Data();
  ~BundleIndexItem_Data() = delete;
};
static_assert(sizeof(BundleIndexItem_Data) == 48,
              "Bad sizeof(BundleIndexItem_Data)");
// Used by BundleIndexItem::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BundleIndexItem_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BundleIndexItem_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BundleIndexItem_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BundleIndexItem_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BundleIndexItem_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  BundleResponse_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BundleResponse_Data));
      new (data()) BundleResponse_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BundleResponse_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BundleResponse_Data>(index_);
    }
    BundleResponse_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t response_code;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::String_Data>>> response_headers;
  uint64_t payload_offset;
  uint64_t payload_length;

 private:
  BundleResponse_Data();
  ~BundleResponse_Data() = delete;
};
static_assert(sizeof(BundleResponse_Data) == 40,
              "Bad sizeof(BundleResponse_Data)");
// Used by BundleResponse::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BundleResponse_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BundleResponse_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BundleResponse_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BundleResponse_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BundleResponse_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace data_decoder

#endif  // SERVICES_DATA_DECODER_PUBLIC_MOJOM_BUNDLED_EXCHANGES_PARSER_MOJOM_SHARED_INTERNAL_H_