// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_FRAME_TIMING_DETAILS_MOJOM_SHARED_H_
#define SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_FRAME_TIMING_DETAILS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/viz/public/interfaces/compositing/frame_timing_details.mojom-shared-internal.h"
#include "ui/gfx/mojo/presentation_feedback.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace viz {
namespace mojom {
class FrameTimingDetailsDataView;



}  // namespace mojom
}  // namespace viz

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::viz::mojom::FrameTimingDetailsDataView> {
  using Data = ::viz::mojom::internal::FrameTimingDetails_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace viz {
namespace mojom {
class FrameTimingDetailsDataView {
 public:
  FrameTimingDetailsDataView() {}

  FrameTimingDetailsDataView(
      internal::FrameTimingDetails_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPresentationFeedbackDataView(
      ::gfx::mojom::PresentationFeedbackDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPresentationFeedback(UserType* output) {
    auto* pointer = data_->presentation_feedback.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PresentationFeedbackDataView>(
        pointer, output, context_);
  }
 private:
  internal::FrameTimingDetails_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace viz

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::viz::mojom::FrameTimingDetailsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::viz::mojom::FrameTimingDetailsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::viz::mojom::internal::FrameTimingDetails_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::presentation_feedback(input)) in_presentation_feedback = Traits::presentation_feedback(input);
    typename decltype((*output)->presentation_feedback)::BaseType::BufferWriter
        presentation_feedback_writer;
    mojo::internal::Serialize<::gfx::mojom::PresentationFeedbackDataView>(
        in_presentation_feedback, buffer, &presentation_feedback_writer, context);
    (*output)->presentation_feedback.Set(
        presentation_feedback_writer.is_null() ? nullptr : presentation_feedback_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->presentation_feedback.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_feedback in FrameTimingDetails struct");
  }

  static bool Deserialize(::viz::mojom::internal::FrameTimingDetails_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::viz::mojom::FrameTimingDetailsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace viz {
namespace mojom {

inline void FrameTimingDetailsDataView::GetPresentationFeedbackDataView(
    ::gfx::mojom::PresentationFeedbackDataView* output) {
  auto pointer = data_->presentation_feedback.Get();
  *output = ::gfx::mojom::PresentationFeedbackDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_FRAME_TIMING_DETAILS_MOJOM_SHARED_H_