// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "third_party/blink/public/mojom/frame/document_interface_broker.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include "third_party/blink/public/mojom/appcache/appcache.mojom.h"
#include "third_party/blink/public/mojom/credentialmanager/credential_manager.mojom.h"
#include "third_party/blink/public/mojom/frame/frame_host_test_interface.mojom.h"
#include "third_party/blink/public/mojom/push_messaging/push_messaging.mojom.h"
#include "third_party/blink/public/mojom/webaudio/audio_context_manager.mojom.h"
#include "third_party/blink/public/mojom/webauthn/authenticator.mojom.h"
#include "third_party/blink/public/mojom/webauthn/virtual_authenticator.mojom.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_DOCUMENT_INTERFACE_BROKER_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_DOCUMENT_INTERFACE_BROKER_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#endif


namespace blink {
namespace mojom {


void DocumentInterfaceBrokerInterceptorForTesting::GetAudioContextManager(mojo::PendingReceiver<::blink::mojom::AudioContextManager> receiver) {
  GetForwardingInterface()->GetAudioContextManager(std::move(receiver));
}
void DocumentInterfaceBrokerInterceptorForTesting::GetAuthenticator(mojo::PendingReceiver<::blink::mojom::Authenticator> receiver) {
  GetForwardingInterface()->GetAuthenticator(std::move(receiver));
}
void DocumentInterfaceBrokerInterceptorForTesting::GetCredentialManager(mojo::PendingReceiver<::blink::mojom::CredentialManager> receiver) {
  GetForwardingInterface()->GetCredentialManager(std::move(receiver));
}
void DocumentInterfaceBrokerInterceptorForTesting::GetFrameHostTestInterface(mojo::PendingReceiver<::blink::mojom::FrameHostTestInterface> receiver) {
  GetForwardingInterface()->GetFrameHostTestInterface(std::move(receiver));
}
void DocumentInterfaceBrokerInterceptorForTesting::GetPushMessaging(mojo::PendingReceiver<::blink::mojom::PushMessaging> receiver) {
  GetForwardingInterface()->GetPushMessaging(std::move(receiver));
}
void DocumentInterfaceBrokerInterceptorForTesting::GetVirtualAuthenticatorManager(mojo::PendingReceiver<::blink::test::mojom::VirtualAuthenticatorManager> receiver) {
  GetForwardingInterface()->GetVirtualAuthenticatorManager(std::move(receiver));
}
void DocumentInterfaceBrokerInterceptorForTesting::RegisterAppCacheHost(mojo::PendingReceiver<::blink::mojom::AppCacheHost> host_receiver, mojo::PendingRemote<::blink::mojom::AppCacheFrontend> frontend_remote, const base::UnguessableToken& host_id) {
  GetForwardingInterface()->RegisterAppCacheHost(std::move(host_receiver), std::move(frontend_remote), std::move(host_id));
}
DocumentInterfaceBrokerAsyncWaiter::DocumentInterfaceBrokerAsyncWaiter(
    DocumentInterfaceBroker* proxy) : proxy_(proxy) {}

DocumentInterfaceBrokerAsyncWaiter::~DocumentInterfaceBrokerAsyncWaiter() = default;






}  // namespace mojom
}  // namespace blink

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif